找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1120|回复: 0

[分享] Intersect an outerloop of hatch with curves

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 01:24:00 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
        [CommandMethod("hat", CommandFlags.Modal)]
        public static void IntersectHatchWithCurves()
        {

            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
            Editor ed = doc.Editor;
            Database db = doc.Database;

            Transaction tr = db.TransactionManager.StartTransaction();
            using (tr)
            {
                try
                {
                    BlockTableRecord btr = (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite, false) as BlockTableRecord;
                    PromptEntityOptions peo = new PromptEntityOptions("\nSelect a hatch: ");
                    peo.SetRejectMessage("Select hatch only!");
                    peo.AddAllowedClass(typeof(Hatch), true);
                    PromptEntityResult res = doc.Editor.GetEntity(peo);
                    if (res.Status != PromptStatus.OK) return;
                    // Point3d pt = res.PickedPoint;
                    Entity ent = tr.GetObject(res.ObjectId, OpenMode.ForRead, false) as Entity;
                    Hatch hat = ent as Hatch;
                    if (hat == null)
                    {
                        Autodesk.AutoCAD.ApplicationServices.Application.ShowAlertDialog("No luck, mate...");
                        return;
                    }
                    // get outer loop of hatch
                    HatchLoop loops = hat.GetLoopAt(0);
                    Polyline pline = new Polyline();
                 if (loops.IsPolyline)
                 {
                     DoubleCollection bulgcoll=new DoubleCollection();
                     Point2dCollection pts=new Point2dCollection();
                     BulgeVertexCollection bulges =  loops.Polyline;

                    for (int i=0;i<bulges.Count;i++)
                    {
                        BulgeVertex bulg = bulges;
                        bulgcoll.Add(bulg.Bulge);
                        pts.Add(bulg.Vertex);
                    }
                     // create polyline around of the hatch
                     pline = new Polyline(bulges.Count);
                    for (int n = 0; n < pts.Count; n++)
                    {
                        pline.AddVertexAt(n, pts[n], bulgcoll[n], 0, 0);
                    }
                     // commented lines used just for debug only
                    //btr.AppendEntity(pline);
                    //tr.AddNewlyCreatedDBObject(pline, true);
                    //pline.ColorIndex = 5;
                 }

                    // select all intersection curves on layer "0"
                 TypedValue[] tvs = new TypedValue[] {
              new TypedValue((int) DxfCode.Start, "arc,circle,line,lwpolyline,spline"),
              new TypedValue((int) DxfCode.LayerName, "0")
            };
                 SelectionFilter sf = new SelectionFilter(tvs);
                 PromptSelectionOptions pso = new PromptSelectionOptions();
                    pso.MessageForRemoval="\nwrong object selected!";
                 pso.MessageForAdding = "\nSelect curves separately one by another: ";
                 PromptSelectionResult psr = ed.GetSelection(pso,sf);
                 int count = 0;
                 if (psr.Status == PromptStatus.OK)
                 {
                     count = psr.Value.GetObjectIds().Length;

                     ed.WriteMessage("\nSelected:    " + count.ToString());

                 }
                 else
                 {
                     ed.WriteMessage("\nBad selection");
                     return;

                 }

                 foreach (SelectedObject selobj in psr.Value)
                 {
                     
                         DBObject obj = tr.GetObject(selobj.ObjectId, OpenMode.ForRead) as DBObject;
                         Curve curv = obj as Curve;
                         if (obj.ObjectId != pline.ObjectId)
                         {
                         Point3dCollection ipts = new Point3dCollection();
                         // next line is may have another syntax for other Acad release
                         pline.IntersectWith(curv, Intersect.OnBothOperands, ipts, (int)IntPtr.Zero, (int)IntPtr.Zero);

                         if (ipts.Count > 0)
                         {
                             foreach (Point3d pt in ipts)
                             {
                                 // draw circles in intersection for dispaying the result
                                 Circle circ = new Circle(pt, Vector3d.ZAxis, 0.5);
                                 btr.AppendEntity(circ);
                                 tr.AddNewlyCreatedDBObject(circ, true);
                                 circ.ColorIndex = 2;
                             }
                         }
                     }
                 }
                    tr.Commit();
                }
                catch (Autodesk.AutoCAD.Runtime.Exception ex)
                {
                    ed.WriteMessage("\n" + ex.Message + "\n" + ex.StackTrace);

                }
                finally
                {

                }
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 22:19 , Processed in 0.179063 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表